<?php
require('./tools/seqtools.php');// include sequence functions, parsing etc.
require('./tools/formtools.php');
require('./tools/reporttools.php');

// Form buttons from main form
$submit = $_POST['submit'];
$submit_example = $_POST['submit_example'];

$seqs1=$_POST['seqs1'];
$s1_f=$_FILES['seqs1_file'];
if ($s1_f['error']==0 and $s1_f['size'] > 0) {
  $seqs1=file_get_contents($s1_f['tmp_name']); 
}
$seqs1=chop($seqs1);

$seqs2=$_POST['seqs2'];
$s2_f=$_FILES['seqs2_file'];
if ($s2_f['error']==0 and $s2_f['size'] > 0) {
  $seqs2=file_get_contents($s2_f['tmp_name']); 
}
$seqs2=chop($seqs2);


function parse_sequences ($inputseqs) {
  $sequences = parse_fasta($inputseqs, 0, "-"); // returns array of sequences, each consist of two elements: header and sequence, i.e. $var[0][0] = header of seq 1, $var[0][1] = sequence 1 etc...
  if (count($sequences) ==0){
    $error = "Couldn't parse FASTA input correctly, please submit fasta formatted sequences";
    return array(1,$error);
  }
  return array(0,$sequences);
}

function join_sequences($s1,$s2) {
  $seqs[][]="";
  for ($i=0; $i<count($s1); $i++) {       // all sequences
    $seqs[$i][0] = $s1[$i][0];            // headers
    $seqs[$i][1] = $s1[$i][1].$s2[$i][1]; // sequences
  }
  return array(0,$seqs); // return new sequence
}

function get_seq_report($seqs) {
  $r['text'].= sequences2fasta($seqs,60);
  $r['html'].= "<PRE>".$r['text']."</PRE>\n";
  $r['textlabel']="Alignment in fasta format";
  $r['htmllabel']="Alignment in fasta format";
  $r['filename']="alignment.fasta";
  $r['filelabel']="Save joined alignment";
  return $r;
}

if ($submit) {
  $s1= parse_sequences($seqs1);
  $s2= parse_sequences($seqs2);
  if ($s1[0]<>"0") {
    $error = "Alignment 1: ".$s1[1];
    $r='';
  } elseif ($s2[0]<>"0") {
    $error = "Alignment 2: ".$s2[1];
    $r='';
  } elseif (count($s1[1]) <> count($s2[1]) ) {
    $error = "The alignments hold different number of sequences";
    $r='';
  } else {
    $r= join_sequences($s1[1],$s2[1]);
    $report=get_seq_report($r[1]);
    $r='';
  }
  
}
//
// BEGIN HTML OUTPUT!
//
show_page_header("Fasta alignment joiner", "<a href='#formtools.results'>Analysis finished, results are at bottom (or click here)</a>", $submit, $error);
?>

<!-- INPUT FORM -->
<form action="#" method='POST' enctype='multipart/form-data'>

<!-- Alignment 1  -->
<table width="100%"><tr><td>
<?php
show_fieldset_inputseqs ($submit_example, $seqs1, "./examples/alignment_joiner1.fa",10,65,"seqs1") 
?>

</td><td>
<!-- Alignment 2  -->
<?php
show_fieldset_inputseqs ($submit_example, $seqs2, "./examples/alignment_joiner2.fa",10,65,"seqs2") 
?>


</td></tr>

<tr><td colspan=2>

<!-- Settings fieldset -->

<fieldset>
<legend>Settings</legend>
<?php
show_submit_buttons ($mm="Join alignments")
?>
</fieldset>

</td></tr></table>

</form>


<!-- RESULTS SECTION  -->

<?php
   if ($error) {
     print "<h1><font color ='#AA0000'><br> $error</font></h1>\n";
   }
 
  if ($submit and !$error) {
    print "<a name='formtools.results'>";
    $b[] = get_save_button($report, 'r1');
    print get_save_form($b, "Save joined alignment");
    print get_results_from_buttons($b);

}

//
// END HTML OUTPUT
//
show_page_footer();
?>
