<?php
require('./tools/formtools.php');
require('./tools/seqtools.php');// include sequence functions, parsing etc.

// Form buttons from main form
$submit = $_POST['submit'];
$submit_example = $_POST['submit_example'];

function parse_sequences ($inputseqs) {
  $sequences = parse_fasta($inputseqs, 0, "-"); // returns array of sequences, each consist of two elements: header and sequence, i.e. $var[0][0] = header of seq 1, $var[0][1] = sequence 1 etc...
  if (count($sequences) ==0){
    $error = "Couldn't parse FASTA input correctly, please submit fasta formatted sequences";
    return array(1,$error);
  }
  return array(0,$sequences);
}

function checkgaps($seq,$s,$e) {
  preg_match('/^(-|~)*/', $seq,$m);
  $sg= strlen($m[0]);
  preg_match('/(-|~)*$/', $seq,$m);
  $eg= strlen($m[0]);
  if ($sg > $s) {
    $s=$sg;
  }
	
  $e2=strlen($seq)-$eg; // length of sequence until trailing gaps begin

  if ($e2 < $e) {
    $e=$e2;
  }

  $r[0]=$s;
  $r[1]=$e;
  return $r;
}

function get_cropped_alignments ($sequences) {
  $sgaps=0;
  $endpos=strlen($sequences[0][1]); // length of sequence 1
  foreach ($sequences as $seq) {
    $r=checkgaps($seq[1],$sgaps,$endpos);
    $sgaps  = $r[0];
    $endpos = $r[1];
  }

  $r['text'].="";
  $r['html'].="<PRE>";
  
  foreach ($sequences as $seq) {
    $r['text'] .= ">".$seq[0]."\n";
    $r['text'] .= substr($seq[1],$sgaps, $endpos-$sgaps)."\n\n";

    $r['html'] .= "<span style='background-color: #ffaaaa'>".substr($seq[1],0,$sgaps)."</span>";
    $r['html'] .= "<span style='background-color: #aaddaa'>".substr($seq[1], $sgaps, $endpos-$sgaps)."</SPAN>";
    $r['html'] .= "<span style='background-color: #ffaaaa'>".substr($seq[1], $endpos, strlen($seq[1]) )."</SPAN>\n";
  }

  $r['text'].="";
  $r['html'].="</PRE>";


  $r['textlabel']="Cropped alignment in fasta format";
  $r['htmllabel']="Alignment blocks (red=cropped, green=kept) ";

  $r['filename']="cropped_alignment.fasta";
  $r['filelabel']="Save cropped alignment to disk ";

  return $r;
}

if ($submit) {
  $r= parse_sequences($inputseqs);
  if ($r[0]=="0") {
    $sequences=$r[1];
    $al= get_cropped_alignments($sequences);
  } else {
    $error = $r[1];
  }
  unset($r);
}
//
// BEGIN HTML OUTPUT!
//
show_page_header("Alignment trimmer (fasta files)", "<a href='#formtools.results'>Analysis finished, results are at bottom (or click here)</a>", $submit, $error);
?>
<!-- INPUT FORM -->
<form action="#" method='POST' enctype='multipart/form-data'>
<?php
show_fieldset_inputseqs ($submit_example, $inputseqs, "./examples/alignment_trimmer.fa") 
?>
<P>
<!-- Settings fieldset -->
<fieldset>
<legend>Action</legend>
<?php
show_submit_buttons("Trim alignment");
?>
</fieldset>
</form>

<?php
if ($submit and !$error) {
  $b[] = get_save_button($al, 'r1');
  print get_save_form($b, "Save trimmed alignment");
  print get_results_from_buttons($b);
}

show_page_footer();
?>

