<?php
require('./tools/seqtools.php');// include sequence functions, parsing etc.
require('./tools/formtools.php');
require('./tools/reporttools.php');

// Form buttons from main form
$submit = $_POST['submit'];
$submit_example = $_POST['submit_example'];
$headers=$_POST['headers'];
if ($submit_example) {
  unset($headers);
}

function parse_sequences ($inputseqs) {
  $sequences = parse_fasta($inputseqs, 0, "-"); // returns array of sequences, each consist of two elements: header and sequence, i.e. $var[0][0] = header of seq 1, $var[0][1] = sequence 1 etc...
  if (count($sequences) ==0){
    $error = "Couldn't parse FASTA input correctly, please submit fasta formatted sequences";
    return array(1,$error);
  }
  return array(0,$sequences);
}

function get_seq_report($seqs) {
  $s= sequences2fasta($seqs);
  $r['text'].= sequences2fasta($seqs,60);
  $r['html'].= "<PRE>".$r['text']."</PRE>\n";
  $r['textlabel']="Sequences in fasta format";
  $r['htmllabel']="Sequences in fasta format";
  $r['filename']="sequences.fasta";
  $r['filelabel']="Save sequences";
  return $r;
}

function extract_headers($seqs) {
  for ($i=0; $i<count($seqs); $i++) {
    $h[$i]=$seqs[$i][0];
  } 
  return( implode("\n",$h) );
}

function replace_headers($seqs, $h) {
  $headers=explode("\n",$h);
  for ($i=0; $i<count($headers); $i++) {// Chop off newlines
    $headers[$i]=chop($headers[$i]);
  }
  for ($i=0; $i<count($seqs); $i++) {
    $newseqs[$i][1]=$seqs[$i][1];
    $newseqs[$i][0]=$headers[$i];
  } 
  return($newseqs);
}

if ($submit) {
  $r= parse_sequences($inputseqs);
  if ($r[0]=="0") {
    $sequences=$r[1];
    if (!$headers) {
      $newheaders=extract_headers($sequences);
    } else {
      $newheaders=$headers;
      $s1=replace_headers($sequences, $newheaders);
      $s2=get_seq_report($s1);
    }      
    $r='';
  } else {
    $error = $r[1];
    $r='';
  }
 }

//
// BEGIN HTML OUTPUT!
//
if (!$headers) {
show_page_header("Fasta header editor", "Headers extracted, ready for editing", $submit, $error);
} else {
show_page_header("Fasta header editor", "<a href='#formtools.results'>Analysis finished, results are at bottom (or click here)</a>", $submit, $error);
}  
?>

<!-- INPUT FORM -->
<form action="#" method='POST' enctype='multipart/form-data'>
<?php
show_fieldset_inputseqs ($submit_example, $inputseqs, "./examples/fasta_splitter.fa") 
?>
<P>
<fieldset>
<legend>Edit the headers</legend>
<textarea name='headers' rows='10' cols='65' wrap='OFF'>
<?php 
print $newheaders; 
?>
</textarea>
</fieldset>
<P>
<!-- Settings fieldset -->
<fieldset>
<legend>Settings</legend>
<?php
if ($submit and $newheaders) {
  show_submit_buttons ($mm="Apply changes");
} else   {
  show_submit_buttons ($mm="Extract headers");
 }  
?>
</fieldset>
</form>
<!-- RESULTS SECTION  -->
<?php
   if ($error) {
     print "<h1><font color ='#AA0000'><br> $error</font></h1>\n";
   }
  if ($submit and !$error and $headers) {
    print "<a name='formtools.results'>";
    $b[] = get_save_button($s2, 'r1');
    print get_save_form($b, "Save datasets");
    print get_results_from_buttons($b);
}
//
// END HTML OUTPUT
//
?>
<?php
show_page_footer();
?>
