<?php
require('./tools/seqtools.php');// include sequence functions, parsing etc.
require('./tools/formtools.php');
require('./tools/reporttools.php');

// Form buttons from main form
$submit = $_POST['submit'];
$submit_example = $_POST['submit_example'];
$adv_delimiter=$_POST['adv_delimiter'];

function parse_sequences ($inputseqs) {
  $sequences = parse_fasta($inputseqs, 0, "-"); // returns array of sequences, each consist of two elements: header and sequence, i.e. $var[0][0] = header of seq 1, $var[0][1] = sequence 1 etc...
  if (count($sequences) ==0){

    $error = "Couldn't parse FASTA input correctly, please submit fasta formatted sequences";
    return array(1,$error);
  }
  return array(0,$sequences);
}


function create_header_report($seqs, $d="") {
  $header_report_header ="Original headers";
  if ($d<>"") {
    $header_report_header .="\tHeader fields split by '$d'\n";
  } else {
    $header_report_header .="\n";
      }

  foreach ($seqs as $seq){
    $header_report .= $seq[0];
    
    if ($d<>"") { // If no delimiter is supplied, we won't split it
      $headerfields = explode($d, $seq[0]);
      if (count($headerfields)>1) { // if nothing was splitted we won't report it.
	foreach ($headerfields as $h) {
	  $header_report .= "\t".$h;
	}
      }
    } 
    $header_report.="\n";
  }

  $header_report = $header_report_header.$header_report;

  $r['text']=$header_report;
  $r['html']=rt_tsv2htmltable($header_report, 'tableborder');
  $r['textlabel']="Extracted headers from fasta file in tab sep. format";
  $r['htmllabel']="Extracted headers from fasta file in tab sep. format";

  $r['filename']="headers.tsv";
  $r['filelabel']="Save extracted headers to disk";
  return array(0,$r);
}

if ($submit) {
  $r= parse_sequences($inputseqs);
  if ($r[0]=="0") {
    $sequences=$r[1];
    $r= create_header_report($sequences, $adv_delimiter);
    $header_report= $r[1];
    $r='';
  } else {
    $error = $r[1];
    $r='';
  }
}
//
// BEGIN HTML OUTPUT!
//
show_page_header("Fasta header extractor and splitter", "<a href='#results'>Analysis finished, results are at bottom (or click here)</a>", $submit, $error);
?>

<!-- INPUT FORM -->
<form action="#" method='POST' enctype='multipart/form-data'>
<?php
show_fieldset_inputseqs ($submit_example, $inputseqs, "./examples/editheaders.fa") 
?>

<P>
<!-- Settings fieldset -->
<fieldset>
<legend>Settings</legend>
<P><label for="adv_limiter">(Optional) Split headers into fields using this character: </label><input type="text" name ="adv_delimiter" size=10 value="<?php if($adv_delimiter) {echo $adv_delimiter;} else {echo "|";} ?>"/>
</p>

<?php
show_submit_buttons("Extract headers");
?>
</fieldset>
</form>

<!-- RESULTS SECTION  -->

<?php
   if ($error) {
     print "<h1><font color ='#AA0000'><br> $error</font></h1>\n";
   }
 
  if ($submit and !$error) {
    print "<a name='results'>";
  $b[] = get_save_button($header_report, 'r1');

  print get_save_form($b, "Save extracted headers");
  print get_results_from_buttons($b);

}

//
// END HTML OUTPUT
//

?>
<?php
show_page_footer();
?>
