<?php
require('./tools/seqtools.php');// include sequence functions, parsing etc.
require('./tools/formtools.php');// include sequence functions, parsing etc.

// Form buttons from main form
$submit = $_POST['submit'];
$submit_example = $_POST['submit_example'];

$search=$_POST['search'];
$replace=$_POST['replace'];
$exactmatch=$_POST['exactmatch'];

$search=chop($search);
$replace=chop($replace);

function parse_sequences ($inputseqs) {
  $sequences = parse_fasta($inputseqs, 0, "-"); // returns array of sequences, each consist of two elements: header and sequence, i.e. $var[0][0] = header of seq 1, $var[0][1] = sequence 1 etc...
  if (count($sequences) ==0){
    $error = "Couldn't parse FASTA input correctly, please submit fasta formatted sequences";
    return array(1,$error);
  }
  return array(0,$sequences);
}


function replace_headers($seqs, $s, $r, $exact) {
  $s=explode("\n", $s);
  $r=explode("\n",$r);
  for ($i=0; $i<count($s); $i++) {// Chop off newlines
    $s[$i]=chop($s[$i]);
  }
  for ($i=0; $i<count($r); $i++) {// Chop off newlines
    $r[$i]=chop($r[$i]);
  }
  if (count($seqs) <> count($r) and (count($s)==1 and $s[0]=="") ) { 
    return array(1, "Number of sequences does not match number of replace terms (Sequences: ".count($seqs).", Replace: ".count($r).")" );
  }
  if (count($r)==1 and $r[0]=="")  {
    return array(1,"Nothing to replace with");
  }
  if ($exact<>"" and count($s) <> count($r) ) {
    return array(1, "Unbalanced numer of search and replace terms (Search: ".count($s).", Replace: ".count($r).")" );
  }
   
  for ($i=0; $i<count($seqs); $i++) {// all sequences
    $header=$seqs[$i][0];
    $newseqs[$i][1]=$seqs[$i][1];
    if ($s[0]=="") { // REPLACE BY SEQUENCE
      $newheader=$r[$i];
    } 
    elseif ($exact<>"") {    // Perform exact matching between sequence header and search header
      if (($key = array_search($header, $s)) !== FALSE) {
	$newheader=$r[$key];
      } 
      else {
	$warnings .= "Warning, sequence ".($i+1)." ($header) didn't exactly match any of your searchterms\n";
	$newheader=$header;
      }
    } else {     // Non exact matching - for each header look through the search terms and make fuzzy matching
      $newheader="";
      for ($k=0; $k<count($s); $k++) {// all search terms
	$pos1 = stripos($header, $s[$k]);
	  if ($pos1 === false) {
	  } else {
	    $newheader=$r[$k];
	    break;
	  }
      }
      if ($newheader=="") {
	$warnings .= "Warning, sequence ".($i+1)." ($header) didn't match any of your searchterms\n";
	$newheader=$header;
      }
    }
    $newseqs[$i][0]=$newheader;
  }

  $fullset ="";
  foreach ($newseqs as $current){
    $fullset .= ">".$current[0]."\n";
    $fullset .= wrap_sequence($current[1], 70, "\n");
    $fullset .= "\n";
  }
  
  $r['text'] = $fullset;
  $r['html'] = "<PRE>".$fullset."</PRE>\n";

  $r['textlabel']="Sequences in fasta format";
  $r['htmllabel']="Sequences in fasta format";

  $r['filename']="new_sequences.fasta";
  $r['filelabel']="Sequences in fasta format";
  return array(0,$r, $warnings);
}

if ($submit) {
  $r= parse_sequences($inputseqs);
  if ($r[0]==1) {    $error=$r[1];  }
  $sequences=$r[1];
  $r= replace_headers($sequences, $search, $replace, $exactmatch);
  if ($r[0]==1) {    $error=$r[1];  }
  $sequences_new= $r[1];
  $warnings=$r[2];
  unset($r);
}
//
// BEGIN HTML OUTPUT!
//
show_page_header("Fasta header replacer", "<a href='#results'>Analysis finished, results are at bottom (or click here)</a>", $submit, $error);
?>
<form action="#" method='POST' enctype='multipart/form-data'>
<table>
<tr>
<td>
<?php
show_fieldset_inputseqs ($submit_example, $inputseqs, "./examples/replaceheaders.fa", 10 , 40) 
?>
</td>
<td>
<!-- Old headers -->
<P>
<fieldset>
<legend>Optional: input header search terms (to search the old headers)</legend>
<textarea name='search' rows='10' cols='40' wrap='OFF'>
<?php 
if ($submit_example) { 
  print file_get_contents ("./examples/replaceheaders_search.txt"); } 
else { print $search; }
?>
</textarea>
<br>
</fieldset>
</td>
</tr>

<tr>
<td>

<!-- New headers -->
<P>
<fieldset>
<legend>Input the new headers, one per sequence</legend>
<textarea name='replace' rows='10' cols='40' wrap='OFF'>
<?php 
if ($submit_example) { 
  print file_get_contents ("./examples/replaceheaders_replace.txt"); } 
else { print $replace; }
?>
</textarea>
</fieldset>

</td>



<td>
<!-- Settings -->
<P>
<fieldset>
<legend>Settings</legend>
<P>
<label>Search terms must EXACTLY match the old headers</label><input type="checkbox" name="exactmatch" value="exactmatch" <?php if($exactmatch){echo 'checked';}?>/>
</P>
<?php
show_submit_buttons ($mm="Replace headers")
?>
</fieldset>

</td>
</tr>
</table>

</form>
<P>

<?php
if ($error) {
  print "<h1><font color ='#AA0000'><br> $error</font></h1>\n";
}

if ($submit and !$error) {
  print "<a name='results'>";
  print "<fieldset><legend>".count($sequences)." sequences were analysed</legend>\n";
  if ($warnings) {
    print "<h3>Warnings from the program</h3>";
    print "<PRE>$warnings</PRE>";
  } else {
    print "<h3>No warnings</h3>";
  }
  print "</fieldset><P>";
  $b[] = get_save_button($sequences_new, 'r1');
  print get_save_form($b, "Save new sequences");
  print get_results_from_buttons($b);
  
}
?>



<?php
show_page_footer();
?>
