<?php
require_once('./tools/formtools.php');
require_once(dirname(__FILE__)."/config.inc.php");
$this_fabox_version=file("version.txt");
$tdw=300;
show_page_header("Welcome to FaBox (".rtrim($this_fabox_version[0]).") - an online fasta sequence toolbox");

print "<!-- Logo and update notification table -->\n";

if ($fabox_logo=="on") {
	$logo="<table width='100%'>\n";
	$logo.="<tr><td>\n";
	$logo.="<!-- Logo -->\n";
	$logo.="<img src='images/fabox_logo.png' align='left'>";
	$logo.="</td>";
} else {
	$logo=$fabox_alternative_logo."\n";
}
print $logo;

if ($fabox_logo == "on") {
	print "\n<td width='100%' nowrap>\n";
 } else {
	print "\n<table width='100%'><tr><td width='100%' nowrap>\n";
 }
// Table cell with news
print "<!-- News file content shown in textarea -->\n";
$newsfile='news_fabox.txt';
if (file_exists($newsfile)) {
  print "<textarea style='margin:0; padding:5px; width:100%;height:154px;' name='message' wrap='ON' scroll='auto'>";
  print file_get_contents($newsfile);
  print "</textarea>";
}
// End row after news section
print "</td></tr></table>";

?>
<!-- Content  -->
<fieldset>
<legend>Sequence 2 fasta converters (external tools)</legend>
<a href="http://hcv.lanl.gov/content/sequence/FORMAT_CONVERSION/form.html" target="_blank">HCV Sequence Conversion Interface</a>
 - <a href="http://www.ebi.ac.uk/cgi-bin/readseq.cgi" target="_blank">ReadSeq at EBI</a>
</fieldset>
<P>
<fieldset>
<legend>Working with fasta headers</legend>
<table>

<tr><td width='<?php echo $tdw;?>'>
<a href="header_extractor.php">Fasta header extractor (and header splitter)</a>
</td><td>
Simple and fast way of extraction the headers from fasta files - and optionally split each header into fields based on a chosen character/word.
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="header_editor.php">Fasta header editor</a>
</td><td>
Simple and fast way of extracting headers, edit them and reapplying them without worrying about the sequence itself.
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="header_replacer.php">Fasta header replacer</a>
</td><td>
Some programs do not like the fancy headers in fasta files and you have to live with short, unique names - that are really non-descriptive. Here you can replace headers back and forth by submitting old and new headers - which you'll typically keep in a excel spreadsheet.
</td></tr>

</table>
</fieldset>
<P>

<fieldset>
<legend>Working with fasta datasets/alignments</legend>
<table>

<tr><td width='<?php echo $tdw;?>'>
<a href="fasta_extractor.php">Fasta sequence extractor</a>
</td><td>
Simple and fast way of extracting some sequences from a large sequence set, based on a list of headers or fuzzy matching.
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="fasta_subtractor.php">Fasta sequence subtractor</a>
</td><td>
Simple and fast way of removing some sequences from a large sequence set, based on a list of headers or fuzzy matching.
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="fasta_joiner.php">Fasta sequence joiner</a>
</td><td>
Simple and fast way of joining a set of fasta sequences into one sequence
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="fasta_splitter.php">Fasta dataset splitter/divider</a>
</td><td>
Simple and fast way of dividing your dataset into two sets by a header
keyword. It will split into sets WITH and WITHOUT the given header keyword (like 'females/males', 'population1/population2')
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="alignment_joiner.php">Fasta alignment joiner</a>
</td><td>
Simple and fast way of joining two alignments, sequence by sequence. It will join alignment 1,sequence 1 with alignment 2, sequence 1 and so on.... (see example)
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="alignment_trimmer.php">Alignment trimmer</a>
</td><td>
Trims an alignment to the shortest sequence. It simply removes the boundary areas that are full of gaps.
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="alignment_variable_sites.php">Show variable sites only</a>
</td><td>
Extracts all the variable sites from an alignment
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="dnacollapser.php">DNA to haplotype collapser and converter</a>
</td><td>
Will collapse a set of sequences into haplotypes and output som simple statistics and formatted input files for Arlequin
</td></tr>

</table>
</fieldset>

<P>
<fieldset>
<legend>Data conversion</legend>
<table>

<tr><td width='<?php echo $tdw;?>'>
<a href="newick_parser.php">Strip branch lengths and bootstrap values from newick trees (newick parser)</a>
</td><td>
Will take a newick tree and create three versions: the original, branch lengths only and topology only (for ASR in paml).
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="fasta2paml.php">Create formatted sequence file for PAML analysis (fasta2paml)</a>
</td><td>
Will format your fasta sequences and create a correct input file for PAML (it's a phylip format with some modifications).
</td></tr>


<tr><td width='<?php echo $tdw;?>'>
<a href="fasta2excel.php">Fasta2excel converter</a>
</td><td>
Will explode a sequence set into tabular format. It's possible to explode sequences base-by-base and to transpose (flip) the resulting table.
</td></tr>


<tr><td width='<?php echo $tdw;?>'>
<a href="fasta2tcs.php">Create TCS input file from fasta (fasta2tcs)</a>
</td><td>
Will format your fasta sequences and create a correct input file for the TCS software (TCS: Phylogenetic network estimation using statistical parsimony, Clement et al. 2000).
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="fasta2migrate.php">Create Migrate input file from fasta (fasta2migrate)</a>
</td><td>
Will format your DNA sequences and create a migrate file called 'infile'. The produced file will be correctly formatted to be analysed by migrate.
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="fasta2mrbayes.php">Create MrBayes input file from fasta (fasta2mrbayes)</a>
</td><td>
Will format your DNA sequences and create a MrBayes file, with data and analysis settings included. The produced file will run a series of analyses and produce consensus trees with posterior probabilities.
</td></tr>

<tr><td width='<?php echo $tdw;?>'>
<a href="dnacollapser.php">DNA to haplotype collapser and converter</a>
</td><td>
Will collapse a set of sequences into haplotypes and output som simple statistics and formatted input files for Arlequin
</td></tr>
</table>
</fieldset>

<P>
<fieldset>
<legend>Sequence generation</legend>
<table>

<tr><td width='<?php echo $tdw;?>'>
<a href="random_sequence_generator.php">Random DNA sequence generator</a>
</td><td>
Generates a specified number of random DNA sequences of given length and exact base composition (will also generate sequences of varying length)
</td></tr>

</table>
</fieldset>

<?php
show_page_footer();
?>

