<?php
require('./tools/formtools.php');

$submit =$_POST['submit'];

if (!$submit) {
  $a=0.25;
  $c=0.25;
  $g=0.25;
  $n=10;
  $l1=200;
  $l2=300;
} else {
  $a= floatval($_POST['a']);
  $c= floatval($_POST['c']);
  $g= floatval($_POST['g']);
  $t= floatval($_POST['t']);
  $n= intval($_POST['n']);
  $l1=intval($_POST['l1']);
  $l2=intval($_POST['l2']);
}

function get_random_sequence($l1,$l2,$a,$c,$g,$t, $n=1) {
  $seq="";
  for ($k=0;$k<$n;$k++){
	$l = rand($l1,$l2); // Random length
	//Header
	$header = ">".($k+1)."|random sequence|A: $a|C: $c|G: $g|T: $t|length: $l bp\n";
	// Make sequences
	$s = str_repeat("a", intval($a*$l) );
	$s .= str_repeat("c", intval($c*$l) );
	$s .= str_repeat("g", intval($g*$l) );
	$s .= str_repeat("t", ($l-strlen($s) ) );
	$s = str_shuffle($s);
	$seq.=$header.$s."\n\n";
	}

  $r['text'] = $seq;
  $r['textlabel']="Random sequence(s) in fasta format ($l1-$l2 bp)";

  $r['html'] = "<PRE>$seq</PRE>\n";
  $r['htmllabel']="$n Random sequences in fasta format ($l1-$l2 bp)";

  $r['filename']= $n."_seqs_".$l1."_".$l2."_bp.fasta";
  $r['filelabel']="Save random sequences to disk ";

  return $r;
}


//
//
//

if ($submit) {
  $randomsequence = get_random_sequence($l1,$l2,$a,$c,$g,$t,$n);
}


//
// HTML OUTPUT
//
show_page_header("Random DNA sequence generator", "Done, results are below", $submit);
?>

<form method="POST">
<fieldset>
<legend>Sequence input</legend>
<p><label>Fraction A: </label> <input type="text" name="a" value="<?PHP echo $a;?>"></p>
<P><label>Fraction C: </label> <input type="text" name = "c" value="<?PHP echo $c;?>"></p>
<P><label>Fraction G: </label>  <input type="text" name ="g" value="<?PHP echo $g;?>"></p>
<P><label>Fraction T<br>(calculated automatically): </label><input type="text" name ="t" value="<?PHP $t=1-$a-$c-$g; echo $t;?>"></p>
<br>
<P><label>Length of sequence: </label> 
<input type="text" name ="l1" value="<?PHP echo $l1;?>"> to 
<input type="text" name ="l2" value="<?PHP echo $l2;?>"> basepairs</P>

<p><label>Number of sequences: </label> <input type="text" name="n" value="<?PHP echo $n;?>"></p>

<p class='submit'>
<input type="submit" name="submit" value="Generate!">
</p>
</fieldset>
</form>
<?php
if ($submit) {
  $b[] = get_save_button($randomsequence, 'r1');
  print get_save_form($b,"Save random sequence");
  print get_results_from_buttons($b);
}

?>
<?php
show_page_footer();
?>

