<?php
require('./tools/seqtools.php');// include sequence functions, parsing etc.
require('./tools/formtools.php');
require('./tools/reporttools.php');

// Form buttons from main form
$submit = $_POST['submit'];
$submit_example = $_POST['submit_example'];
$split=$_POST['split'];
$number=(int)$_POST['number'];

function parse_sequences ($inputseqs) {
  $sequences = parse_fasta($inputseqs, 0, "-"); // returns array of sequences, each consist of two elements: header and sequence, i.e. $var[0][0] = header of seq 1, $var[0][1] = sequence 1 etc...
  if (count($sequences) ==0){
    $error = "Couldn't parse FASTA input correctly, please submit fasta formatted sequences";
    return array(1,$error);
  }
  return array(0,$sequences);
}

function split_sequences_by_keyword($seqs, $split="") {
  foreach ($seqs as $seq){
    if (stripos($seq[0],$split)===false) {
      $seq2[]=$seq;
    } else {
      $seq1[]=$seq;
    }
  }
  return array(0,$seq1,$seq2);
}

function split_sequences_by_number($seqs, $n=0) {
  for ($i=0; $i<count($seqs); $i++) {// all sequences
    $seqset[]=$seqs[$i];
    if (($i+1) % $n==0) {
      $seqset_array[]=$seqset;
      $seqset='';
    }
  }
  if ($seqset<>'') {
    $seqset_array[]=$seqset;
  }  
  return ($seqset_array);
}


function get_seq_report($seqs) {
  $s= sequences2fasta($seqs);
  $r['text'].= sequences2fasta($seqs,60);
  $r['html'].= "<PRE>".$r['text']."</PRE>\n";
  $r['textlabel']="Sequences in fasta format";
  $r['htmllabel']="Sequences in fasta format";
  $r['filename']="sequences.fasta";
  $r['filelabel']="Save sequences";
  return $r;
}

if ($submit) {
  $r= parse_sequences($inputseqs);
  if ($r[0]=="0") {
    $sequences=$r[1];
    if ($number) { 
      // Split by number of sequences
      $newseqs_array= split_sequences_by_number($sequences, $number);
      $r='';
    } else {
      $r= split_sequences_by_keyword($sequences, $split);
      $s1=get_seq_report($r[1]);
      $s2=get_seq_report($r[2]);
      $r='';
    }
  } else {
    $error = $r[1];
    $r='';
  }
 }
//
// BEGIN HTML OUTPUT!
//
show_page_header("Fasta dataset splitter", "<a href='#formtools.results'>Analysis finished, results are at bottom (or click here)</a>", $submit, $error);
?>

<!-- INPUT FORM -->
<form action="#" method='POST' enctype='multipart/form-data'>
<?php
show_fieldset_inputseqs ($submit_example, $inputseqs, "./examples/fasta_splitter.fa") 
?>
<P>
<!-- Settings fieldset -->

<fieldset>
<legend>Chose how to split: by keyword or by number of sequences</legend>
<P>
<label>Use keyword: </label>
<input type="text" name ="split" size=10 value="<?php if($submit) {echo $split;} if ($submit_example) { echo 'Pop1';} ?>" ></p>
<P>
<label>OR use sequences pr. set: </label>
<input type="text" name ="number" size=10 value="<?php if($submit) {echo $number;} if ($submit_example) { echo '0';} ?>" ></p>
<?php
show_submit_buttons ($mm="Split data")
?>
</fieldset>

</form>

<!-- RESULTS SECTION  -->

<?php
   if ($error) {
     print "<h1><font color ='#AA0000'><br> $error</font></h1>\n";
   }
 
if ($submit and !$error) {
  if (!$number) {
    $s1['textlabel']="Sequences WITH '$split' in header";
    $s1['htmllabel']="Sequences WITH '$split' in header";
    $s1['filename']="$split.sequences.fasta";
    $s1['filelabel']="Save sequences";
    
    $s2['textlabel']="Sequences WITHOUT '$split' in header";
    $s2['htmllabel']="Sequences WITHOUT '$split' in header";
    $s2['filename']="no.$split.sequences.fasta";
    $s2['filelabel']="Save sequences";
    $b[] = get_save_button($s1, 'r1');
    $b[] = get_save_button($s2, 'r2'); 
  }
  else {
    $set=1;
    foreach ($newseqs_array as $seqset) {
      $s1=get_seq_report($seqset);
      $s1['textlabel']="Sequence set $set ($number sequences)";
      $s1['htmllabel']="Sequence set $set ($number sequences)";
      $s1['filename']="sequence_set_$set.fasta";
      $s1['filelabel']="Save sequence set $set";
      $b[] = get_save_button($s1, 'r1');
      $set=$set+1;
    }
  }
  print get_save_form($b, "Save datasets");
  print get_results_from_buttons($b);
  
 }

//
// END HTML OUTPUT
//
?>
<?php
show_page_footer();
?>
